﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HandBrake.Interop.Interop;
using PipeMethodCalls;
using VidCoderCommon;

namespace VidCoderWorker
{
	public class HandBrakeScanWorker : HandBrakeWorkerBase<IHandBrakeScanWorkerCallback>, IHandBrakeScanWorker
	{
		public HandBrakeScanWorker(IPipeInvoker<IHandBrakeScanWorkerCallback> callback) 
			: base(callback)
		{
		}

		public void StartScan(string path)
		{
			this.Instance = new HandBrakeInstance();
			this.Instance.Initialize(this.PassedVerbosity);
			this.Instance.ScanProgress += (o, e) =>
			{
				this.MakeOneWayCallback(c => c.OnScanProgress((float)e.Progress));
			};
			this.Instance.ScanCompleted += async (o, e) =>
			{
				try
				{
					await this.CallbackInvoker.InvokeAsync(c => c.OnScanComplete(this.Instance.TitlesJson));
				}
				catch (Exception exception)
				{
					WorkerErrorLogger.LogError("Got exception when reporting completion: " + exception, isError: true);
				}
				finally
				{
					this.CleanUpAndSignalCompletion();
				}
			};

			this.Instance.StartScan(path, this.PassedPreviewCount, TimeSpan.FromSeconds(this.PassedMinTitleDurationSeconds), 0);
		}
	}
}
